define(["require", "exports", "tslib", "@aurelia-mdc-web/base", "@material/linear-progress", "aurelia-typed-observable-plugin", "aurelia-framework"], function (require, exports, tslib_1, base_1, linear_progress_1, aurelia_typed_observable_plugin_1, aurelia_framework_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MdcLinearProgress = void 0;
    /**
     * @selector mdc-linear-progress
     */
    var MdcLinearProgress = /** @class */ (function (_super) {
        tslib_1.__extends(MdcLinearProgress, _super);
        function MdcLinearProgress() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MdcLinearProgress.prototype.progressChanged = function () {
            var _a, _b;
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var determinate;
                return tslib_1.__generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, this.initialised];
                        case 1:
                            _c.sent();
                            determinate = this.progress !== undefined && !isNaN(this.progress);
                            (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.setDeterminate(determinate);
                            if (determinate) {
                                (_b = this.foundation) === null || _b === void 0 ? void 0 : _b.setProgress(this.progress);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        MdcLinearProgress.prototype.bufferChanged = function () {
            var _a;
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, this.initialised];
                        case 1:
                            _b.sent();
                            if (this.buffer !== undefined && !isNaN(this.buffer)) {
                                (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.setBuffer(this.buffer);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        MdcLinearProgress.prototype.openChanged = function () {
            var _a, _b;
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, this.initialised];
                        case 1:
                            _c.sent();
                            if (this.open) {
                                (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.open();
                            }
                            else {
                                (_b = this.foundation) === null || _b === void 0 ? void 0 : _b.close();
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        // eslint-disable-next-line @typescript-eslint/require-await
        MdcLinearProgress.prototype.initialise = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    this.progressChanged();
                    return [2 /*return*/];
                });
            });
        };
        MdcLinearProgress.prototype.getDefaultFoundation = function () {
            var _this = this;
            // DO NOT INLINE this variable. For backward compatibility, foundations take a Partial<MDCFooAdapter>.
            // To ensure we don't accidentally omit any methods, we need a separate, strongly typed adapter variable.
            var adapter = {
                addClass: function (className) {
                    _this.root.classList.add(className);
                },
                forceLayout: function () {
                    _this.root.getBoundingClientRect();
                },
                setBufferBarStyle: function (styleProperty, value) {
                    var bufferBar = _this.root.querySelector(linear_progress_1.MDCLinearProgressFoundation.strings.BUFFER_BAR_SELECTOR);
                    if (bufferBar) {
                        bufferBar.style.setProperty(styleProperty, value);
                    }
                },
                setPrimaryBarStyle: function (styleProperty, value) {
                    var primaryBar = _this.root.querySelector(linear_progress_1.MDCLinearProgressFoundation.strings.PRIMARY_BAR_SELECTOR);
                    if (primaryBar) {
                        primaryBar.style.setProperty(styleProperty, value);
                    }
                },
                hasClass: function (className) { return _this.root.classList.contains(className); },
                removeAttribute: function (attributeName) {
                    _this.root.removeAttribute(attributeName);
                },
                removeClass: function (className) {
                    _this.root.classList.remove(className);
                },
                setAttribute: function (attributeName, value) {
                    _this.root.setAttribute(attributeName, value);
                },
                setStyle: function (name, value) {
                    _this.root.style.setProperty(name, value);
                },
                attachResizeObserver: function (callback) {
                    var RO = window.ResizeObserver;
                    if (RO) {
                        var ro = new RO(callback);
                        ro.observe(_this.root);
                        return ro;
                    }
                    return null;
                },
                // attachResizeObserver: (callback: ResizeObserverCallback) => {
                //   if (window.ResizeObserver) {
                //     const ro = new ResizeObserver(callback);
                //     ro.observe(this.root);
                //     return ro;
                //   }
                //   return null;
                // },
                getWidth: function () { return _this.root.offsetWidth; },
            };
            return new linear_progress_1.MDCLinearProgressFoundation(adapter);
        };
        tslib_1.__decorate([
            aurelia_typed_observable_plugin_1.bindable.number,
            tslib_1.__metadata("design:type", Number)
        ], MdcLinearProgress.prototype, "progress", void 0);
        tslib_1.__decorate([
            aurelia_typed_observable_plugin_1.bindable.number,
            tslib_1.__metadata("design:type", Number)
        ], MdcLinearProgress.prototype, "buffer", void 0);
        tslib_1.__decorate([
            aurelia_typed_observable_plugin_1.bindable.booleanAttr,
            tslib_1.__metadata("design:type", Boolean)
        ], MdcLinearProgress.prototype, "open", void 0);
        MdcLinearProgress = tslib_1.__decorate([
            aurelia_framework_1.inject(Element),
            aurelia_framework_1.useView(aurelia_framework_1.PLATFORM.moduleName('./mdc-linear-progress.html')),
            aurelia_framework_1.customElement('mdc-linear-progress')
        ], MdcLinearProgress);
        return MdcLinearProgress;
    }(base_1.MdcComponent));
    exports.MdcLinearProgress = MdcLinearProgress;
});
//# sourceMappingURL=mdc-linear-progress.js.map